* STD_CODE, component of ST Digger 3.1
* Copyright (C) 1990-2002  Han Driesen
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
* 
* <han.driesen@hccnet.nl> 

r000:	bra.s	scan

	bra.s	find

	bra.s	reloc

nonzer: movea.l $0004(sp),a0
nzloop: tst.l	(a0)+
	beq.s	nzloop
	move.l	a0,d0
	subq.l	#4,d0
	rts

scan:	link	a6,#$00
	pea	scan1(pc)
	move.w	#$0026,-(sp)	; supexec
	trap	#14		; xbios
	addq.l	#6,sp
	unlk	a6
	rts

find:	link	a6,#$00
	pea	find1(pc)
	move.w	#$0026,-(sp)	; supexec
	trap	#14		; xbios
	addq.l	#6,sp
	unlk	a6
	rts

reloc:	movea.l $0004(sp),a0	; org
	move.l	$0008(sp),d7	; bss
	move.l	$000C(sp),d6	; top
	movea.l $0010(sp),a1	; rlc
	movea.l $0014(sp),a2	; limit
	movea.l $0018(sp),a3	; rel
	movea.l $001C(sp),a4	; ref
	sub.l	a0,d7
	subq.l	#4,d7		; d7 = bss - org - 4
	sub.l	a0,d6		; d6 = top - org
	moveq	#$00,d0
	tst.w	-$0002(a0)	; relocation inhibit flag
	bne.s	r_exit
	move.b	(a1)+,d1
	lsl.w	#8,d1
	move.b	(a1)+,d1
	lsl.l	#8,d1
	move.b	(a1)+,d1
	lsl.l	#8,d1
	move.b	(a1)+,d1
	tst.l	d1
	beq.s	r_exit
	cmpa.l	a2,a1
	bhi.s	r_exit		; ptr > limit
	btst	#0,d1
	bne.s	r_fail
r_loop1:add.l	d0,d1
	cmp.l	d7,d1
	bhi.s	r_fail
	move.l	d1,d2
	lsr.l	#3,d2
	bset	d1,$00(a3,d2.l) ; rel(d1) = true
	move.l	$00(a0,d1.l),d2
	cmp.l	d6,d2
	bhi.s	r_loop2
	move.b	d2,d3
	lsr.l	#3,d2
	bset	d3,$00(a4,d2.l) ; ref(d2) = true
r_loop2:cmpa.l	a2,a1
	bcc.s	r_exit		; ptr >= limit
	move.b	(a1)+,d0
	beq.s	r_exit
	btst	#0,d0
	beq.s	r_loop1
	subq.b	#3,d0
	bcc.s	r_fail
	add.l	d0,d1
	bra.s	r_loop2

r_fail: moveq	#$00,d0
	rts

r_exit: move.l	a1,d0
	rts

scan1:	move.b	$000B(a6),d7	; prg
	movea.l $000C(a6),a5	; org
	movea.l $0010(a6),a4	; dat
	move.l	$0014(a6),d3	; top
	move.l	$0018(a6),d6	; offset
	movea.l $0020(a6),a1	; rel
	movea.l $0024(a6),a3	; dt
	move.l	d3,d2
	sub.l	a5,d2
	add.l	d6,d2		; top-org+offset
	tst.b	d7
	bne.s	r070		; prg == true
	movea.l a5,a2
r04a:	lea	$0002(a2),a0
	cmpa.l	d3,a0
	bcc.s	r070		; pc + 2 >= top
	move.l	(a2),d4
	cmp.l	d6,d4
	ble.s	r06c
	cmp.l	d2,d4
	bge.s	r06c
	move.l	d4,d0
	sub.l	d6,d0
	move.b	d0,d1
	lsr.l	#3,d0
	movea.l $0028(a6),a0	; ref
	bset	d1,$00(a0,d0.l) ; ref(d4-offset) = true
r06c:	addq.l	#2,a2
	bra.s	r04a

r070:	movea.l $0028(a6),a0
	bset	#$00,(a0)	; ref(org-org) = true
	move.l	a4,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	bset	d1,$00(a0,d0.l) ; ref(dat-org) = true
	move.l	d3,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	bset	d1,$00(a0,d0.l) ; ref(top-org) = true
	lea	-$0004(a5),a2	; pc = org - 4
s_step4:addq.l	#2,a2
s_step2:addq.l	#2,a2
s_step0:cmpa.l	a4,a2
	bcc	s_exit		; pc >= dat
	move.l	a2,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	tst.b	d7
	beq.s	r0b0		; prg == false
	btst	d1,$00(a1,d0.l) ; rel(pc-org)
	bne.s	s_step4
	addq.b	#1,d1
	btst	d1,$00(a1,d0.l) ; rel(pc+1-org)
	bne.s	s_step2
	subq.b	#1,d1
r0b0:	btst	d1,$00(a3,d0.l) ; dt(pc-org)
	bne.s	s_step2
	addq.b	#1,d1
	btst	d1,$00(a3,d0.l) ; dt(pc+1-org)
	bne.s	s_step2
r0b8:	move.w	(a2)+,d5
	move.w	d5,d0
	andi.w	#$F001,d0
	cmpi.w	#$6000,d0	; bcc
	bne.s	r0d2
	move.b	d5,d4
	beq.s	r0d2		; bcc.l
	ext.w	d4
	ext.l	d4
	bra	mark

r0d2:	cmpa.l	a4,a2
	bcc	s_exit		; pc >= dat
	move.l	a2,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	tst.b	d7
	beq.s	r0ee		; prg == false
	btst	d1,$00(a1,d0.l) ; rel(pc-org)
	bne.s	s_step4
	addq.b	#1,d1
	btst	d1,$00(a1,d0.l) ; rel(pc+1-org)
	bne.s	s_step2
	subq.b	#1,d1
r0ee:	btst	d1,$00(a3,d0.l) ; dt(pc-org)
	bne.s	s_step2
	addq.b	#1,d1
	btst	d1,$00(a3,d0.l) ; dt(pc+1-org)
	bne.s	s_step2
	move.l	d5,d0
	andi.w	#$F0FF,d0
	cmpi.w	#$6000,d0	; bcc.l
	beq.s	r104
	andi.w	#$F0F8,d0
	cmpi.w	#$50C8,d0	; dbcc
	bne.s	r112
r104:	move.w	(a2),d4
	beq.s	r0b8
	ext.l	d4
	btst	#$00,d4
	bne.s	r0b8
	bra	mark

r112:	move.w	d5,d0
	andi.w	#$003E,d0
	cmpi.w	#$003A,d0	; dd(pc), d(pc,rn)
	bne.s	r0b8
	move.w	d5,d0
	lsr.w	#6,d0
	move.b	d0,d1
	lsr.w	#3,d0
	movea.l $001C(a6),a0	; mask
	btst	d1,$00(a0,d0.w)
	beq	r0b8
	move.w	d5,d0
	andi.w	#$FFC0,d0
	cmpi.w	#$0800,d0	; btst #n,<ea>
	beq.s	r146
	andi.w	#$FF80,d0
	cmpi.w	#$4C80,d0	; movem.s <ea>,<reglist>
	bne.s	r18e
r146:	lea	$0002(a2),a0
	cmpa.l	a4,a0
	bcc	r0b8		; pc + 2 >= dat
	move.l	a0,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	tst.b	d7
	beq.s	r168		; prg == false
	btst	d1,$00(a1,d0.l) ; rel(pc+2-org)
	bne	r0b8
	addq.b	#1,d1
	btst	d1,$00(a1,d0.l) ; rel(pc+3-org)
	bne	r0b8
	subq.b	#1,d1
r168:	btst	d1,$00(a3,d0.l) ; dt(pc+2-org)
	bne	r0b8
	addq.b	#1,d1
	btst	d1,$00(a3,d0.l) ; dt(pc+3-org)
	bne	r0b8
	btst	#$00,d5
	beq.s	r184		; d(pc)
	moveq	#$07,d0 	; d(pc,xi)
	and.b	$0002(a2),d0
	bne	r0b8
	move.b	$0003(a2),d4
	ext.w	d4
	ext.l	d4
	addq.l	#2,d4
	bra.s	mark

r184:	move.w	$0002(a2),d4
	ext.l	d4
	addq.l	#2,d4
	bra.s	r1aa

r18e:	btst	#$00,d5
	beq.s	r1a6		; d(pc)
	moveq	#$07,d0 	; d(pc,xi)
	and.b	(a2),d0
	bne	r0b8
	move.b	$0001(a2),d4
	ext.w	d4
	ext.l	d4
	bra.s	mark

r1a6:	move.w	(a2),d4
	ext.l	d4
r1aa:	btst	#$00,d4
	beq.s	mark		; even adres
	cmpi.w	#$2000,d5	; btst, move.b
	bcs.s	mark
	cmpi.w	#$487A,d5	; pea
	beq.s	mark
	andi.w	#$F1C0,d5
	cmpi.w	#$41C0,d5	; lea
	beq.s	mark
	andi.w	#$80C0,d5
	cmpi.w	#$8000,d5	; op.b
	bne	r0b8
mark:	lea	$00(a2,d4.l),a0
	cmpa.l	a5,a0
	bls	s_step0 	; pc + displacement <= org
	cmpa.l	d3,a0
	bcc	s_step0 	; pc + displacement >= top
	move.l	a0,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	movea.l $0028(a6),a0	; ref(pc+displacement-org) = true
	bset	d1,$00(a0,d0.l)
	bra	s_step0

s_exit: rts

find1:	move.b	$000B(a6),d7	; prg
	movea.l $000C(a6),a5	; org
	movea.l $0010(a6),a4	; dat
	move.l	$0014(a6),d3	; top
	move.l	$0018(a6),d6	; reference
	movea.l $0020(a6),a1	; rel
	movea.l $0024(a6),a3	; dt
	movea.l $0028(a6),a2	; pc
	move.l	$002C(a6),d2	; reference + shift
	tst.b	d7
	beq.s	r244		; prg == false
	move.l	a2,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	btst	d1,$00(a1,d0.l) ; rel(pc-org)
	beq.s	r244
	addq.b	#1,d1
	btst	d1,$00(a1,d0.l) ; rel(pc+1-org)
	bne.s	r244
f_step4:addq.l	#2,a2
f_step2:addq.l	#2,a2
	move.l	a2,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	btst	d1,$00(a1,d0.l) ; rel(pc-org)
	beq.s	r242
r240:	addq.b	#1,d1
	btst	d1,$00(a1,d0.l) ; rel(pc+1-org)
	bne.s	f_step2
	cmp.l	(a2),d6
	bne.s	f_step4
	bra	f_exit2

r242:	addq.b	#1,d1
	btst	d1,$00(a1,d0.l) ; rel(pc+1-org)
	bne.s	f_step2
r244:	cmpa.l	d3,a2
	bcc	f_exit		; pc >= top
	move.w	(a2)+,d5
	cmpa.l	a4,a2
	bhi.s	r26c		; pc > dat
	move.w	d5,d0
	andi.w	#$F001,d0
	cmpi.w	#$6000,d0	; bcc
	bne.s	r26c
	move.b	d5,d4
	beq.s	r26c		; bcc.l
	move.l	a2,d0
	subq.l	#2,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	btst	d1,$00(a3,d0.l) ; dt(pc-2-org)
	bne.s	r26c
	addq.b	#1,d1
	btst	d1,$00(a3,d0.l) ; dt(pc-1-org)
	bne.s	r26c
	ext.w	d4
	ext.l	d4
	add.l	a2,d4
	cmp.l	d2,d4
	beq	f_exit2
r26c:	cmpa.l	d3,a2
	bcc	f_exit		; pc >= top
	move.l	a2,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	tst.b	d7		; prg == false
	beq.s	r294
	btst	d1,$00(a1,d0.l) ; rel(pc-org)
	bne.s	r240
	addq.b	#1,d1
	btst	d1,$00(a1,d0.l) ; rel(pc+1-org)
	bne	f_step2
	subq.b	#1,d1
	bra.s	r2a6

r294:	lea	$0002(a2),a0
	cmpa.l	d3,a0		; pc + 2 >= top
	bcc.s	r2a6
	cmp.l	(a2),d6
	beq	f_exit2
r2a6:	cmpa.l	a4,a2
	bcc.s	r244		; pc >= dat
	btst	d1,$00(a3,d0.l) ; dt(pc-org)
	bne.s	r244
	addq.b	#1,d1
	btst	d1,$00(a3,d0.l) ; dt(pc+1-org)
	bne	r244
	move.l	d5,d0
	andi.w	#$F0FF,d0
	cmpi.w	#$6000,d0	; bcc.l
	beq.s	r2c0
	andi.w	#$F0F8,d0
	cmpi.w	#$50C8,d0	; dbcc
	bne.s	r2d0
r2c0:	move.w	(a2),d4
	beq	r244
	ext.l	d4
	btst	#$00,d4
	bne	r244
	bra	r39a

r2d0:	move.w	d5,d0
	andi.w	#$003E,d0
	cmpi.w	#$003A,d0	; dd(pc), d(pc,rn)
	bne	r244
	move.w	d5,d0
	lsr.w	#6,d0
	move.b	d0,d1
	lsr.w	#3,d0
	movea.l $001C(a6),a0	; mask
	btst	d1,$00(a0,d0.w)
	beq	r244
	move.w	d5,d0
	andi.w	#$FFC0,d0
	cmpi.w	#$0800,d0	; btst #n,<ea>
	beq.s	r308
	andi.w	#$FF80,d0
	cmpi.w	#$4C80,d0	; movem.s <ea>,<reglist>
	bne.s	r350
r308:	lea	$0002(a2),a0
	cmpa.l	a4,a0		; pc + 2 >= dat
	bcc	r244
	move.l	a0,d0
	sub.l	a5,d0
	move.b	d0,d1
	lsr.l	#3,d0
	tst.b	d7
	beq.s	r32a		; prg == false
	btst	d1,$00(a1,d0.l) ; rel(pc+2-org)
	bne	r244
	addq.b	#1,d1
	btst	d1,$00(a1,d0.l) ; rel(pc+3-org)
	bne	r244
	subq.b	#1,d1
r32a:	btst	d1,$00(a3,d0.l) ; dt(pc+2-org)
	bne	r244
	addq.b	#1,d1
	btst	d1,$00(a3,d0.l) ; dt(pc+3-org)
	bne	r244
	btst	#$00,d5
	beq.s	r346		; d(pc)
	moveq	#$07,d0 	; d(pc,xi)
	and.b	$0002(a2),d0
	bne	r244
	move.b	$0003(a2),d4
	ext.w	d4
	ext.l	d4
	addq.l	#2,d4
	bra.s	r39a

r346:	move.w	$0002(a2),d4
	ext.l	d4
	addq.l	#2,d4
	bra.s	r36c

r350:	btst	#$00,d5
	beq.s	r368		; d(pc)
	moveq	#$07,d0 	; d(pc,xi)
	and.b	(a2),d0
	bne	r244
	move.b	$0001(a2),d4
	ext.w	d4
	ext.l	d4
	bra.s	r39a

r368:	move.w	(a2),d4
	ext.l	d4
r36c:	btst	#$00,d4 	; even adres
	beq.s	r39a
	cmpi.w	#$2000,d5	; btst, move.b
	bcs.s	r39a
	cmpi.w	#$487A,d5	; pea
	beq.s	r39a
	andi.w	#$F1C0,d5
	cmpi.w	#$41C0,d5	; lea
	beq.s	r39a
	andi.w	#$80C0,d5
	cmpi.w	#$8000,d5	; op.b
	bne	r244
r39a:	add.l	a2,d4
	cmp.l	d2,d4
	bne	r244
f_exit2:subq.l	#2,a2
f_exit: move.l	a2,d0
	rts
r3a8:
	END
